/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.workflows

import javax.sql.DataSource

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 3/3/12
 * Time: 8:50 AM
 */
class LoadingTableToNormalizedTablesWorkflow extends Workflow {

    DataSource dataSource
    Map<String, List<String>> normalizationConfiguration
    String loadingTable
    /**
     * just here for convenience.  This class name is too long
     */
    private static Class THIS_CLASS = LoadingTableToNormalizedTablesWorkflow
    public static final String DATASOURCE_IS_REQUIRED = {
        "Datasource cannot be null for ${THIS_CLASS} to run"
    }
    public static final String PROJECT_NAME_IS_REQUIRED_TO_GET_LOADING_TABLE_NAME = {
        "${THIS_CLASS} requires projectName to be set to extract the loading table name.  Either directly set" +
            " the loadingTable name or provide a projectName"
    }
    String projectName

    String getLoadingTable() {
        return loadingTable
    }

    @Override
    def run() {

    }
}
