/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.workflows

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 1/20/12
 * Time: 3:03 PM
 *
 * @deprecated
 */
class Message<T> implements Cloneable {
    final Map headers
    final T body

    Message(Map headers, body) {
        if (headers == null) {
            this.headers = [:]
        } else {
            this.headers = headers
        }
        this.body = body
    }

    static final String METRIDOC_FILE_NAME = "MetridocFileName"
    static final String METRIDOC_LINE_NUMBER = "MetridocLineNumber"
    static final String METRIDOC_SKIPPED_LINES = "MetridocSkippedLines"

    static Message create() {
        return new Message(null, null)
    }

    static Message createWithBody(body) {
        return new Message([:], body)
    }

    static Message create(LinkedHashMap map) {
        return new Message(map.headers, map.body)
    }

    Map getHeaders() {
        return new HashMap(headers)
    }

    def getBody() {
        return body
    }

    boolean equals(o) {
        if (this.is(o)) return true
        if (getClass() != o.class) return false

        Message message = (Message) o

        if (body != message.body) return false
        if (headers != message.headers) return false

        return true
    }

    int hashCode() {
        int result
        result = (headers != null ? headers.hashCode() : 0)
        result = 31 * result + (body != null ? body.hashCode() : 0)
        return result
    }

    @Override
    public Object clone() {
        return new Message(new HashMap(headers), body)
    }

    @Override
    public String toString() {
        return "Message{" +
            "headers=" + getHeaders() +
            ", body=" + getBody() +
            '}';
    }


}
