/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.workflows.operations.impl

import metridoc.workflows.Message
import metridoc.workflows.operations.DefaultFileHandler

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 2/11/12
 * Time: 4:53 PM
 *
 * @deprecated
 */
class SystemFileHandler extends DefaultFileHandler implements Comparable<File> {
    public static final FILE_CANNOT_BE_NULL = "file cannot be null"
    public static final FILE_DOES_NOT_EXIST = "file {} does not exist"
    File file

    Message<InputStream> getStream() {
        (Message<InputStream>) validateAndDo {

            def fileName = file.name
            def fileUri = file.toURI()
            def headers = [fileName: fileName, fileUri: fileUri]
            def body = new FileInputStream(file)
            return Message.create(body: body, headers: headers)
        }
    }

    String getName() {
        validateAndDo {
            return file.name
        }
    }

    private validateAndDo(Closure closure) {
        assert file: FILE_CANNOT_BE_NULL
        assert file.exists(): FILE_DOES_NOT_EXIST

        return closure.call()
    }

    boolean equals(o) {
        if (this.is(o)) return true
        if (!(o instanceof SystemFileHandler)) return false

        SystemFileHandler that = (SystemFileHandler) o

        if (file != that.file) return false

        return true
    }

    int hashCode() {
        return (file != null ? file.hashCode() : 0)
    }

    int compareTo(File o) {
        this.file.compareTo(o)
    }
}
