/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.workflows.operations.impl.mock

import groovy.util.logging.Slf4j
import metridoc.utils.StringUtils
import metridoc.utils.SystemUtils
import metridoc.workflows.operations.FileHandler
import metridoc.workflows.operations.impl.SystemDirectoryOperations

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 2/17/12
 * Time: 2:21 PM
 *
 * @deprecated
 */
@Slf4j
class MockDirectoryOperations extends SystemDirectoryOperations {
    private List<FileHandler> mockFiles = []
    String newLine = SystemUtils.LINE_SEPARATOR

    MockDirectoryOperations() {
        directory = "mock"
    }

    @Override
    List<String> getFilteredFileNames() {
        def unfilteredList = []
        mockFiles.each {
            unfilteredList.add(it.name)
        }
        return getFilteredFileNames(unfilteredList)
    }

    List<FileHandler> getUnFilteredFiles() {
        return mockFiles
    }

    void addFile(String name, String body) {
        def newBody = new StringBuilder()
        body.eachLine {
            def line = it.trim()
            if (line != StringUtils.EMPTY) {
                newBody.append(line)
                newBody.append(newLine)
            }
        }
        mockFiles.add(new MockFileHandler(text: newBody.toString(), name: name))
    }
}
